#include "struct.hpp"
#include <brick-unit>

struct test_struct : bast::l_struct
{
    using program = bast::builder::program;
    using block   = bast::builder::block;

    block *translate( bast::word op, program &, block &b )
    {
        return &b;
    }
};

struct another_struct : bast::l_struct
{
    using program = bast::builder::program;
    using block   = bast::builder::block;
    int _x;

    another_struct( int x ) : _x( x ) {}

    std::strong_ordering compare( const l_struct &o )
    {
        return _x <=> dynamic_cast< const another_struct & >( o )._x;
    }

    block *translate( bast::word op, program &, block &b )
    {
        return &b;
    }
};

int main()
{
    brq::test_case( "struct_map" ) = []
    {
        bast::struct_map tm;
        auto [ id_1a, st_1a ] = tm.get_id< test_struct >();
        auto [ id_1b, st_1b ] = tm.get_id< test_struct >();
        auto [ id_2a, st_2a ] = tm.get_id< another_struct >( 1 );
        auto [ id_2b, st_2b ] = tm.get_id< another_struct >( 1 );
        auto [ id_3a, st_3a ] = tm.get_id< another_struct >( 2 );

        ASSERT_EQ( id_1a, id_1b );
        ASSERT_EQ( id_2a, id_2b );

        ASSERT_NEQ( id_1a, id_2a );
        ASSERT_NEQ( id_1a, id_3a );
        ASSERT_NEQ( id_2a, id_3a );

        ASSERT_EQ( &st_1a, &st_1b );
        ASSERT_EQ( &st_2a, &st_2b );
    };
}
